--joystick
local self = {}
self.joyStick = {}
self.actionButton = {}
self.joyStick.base_bitmap = Bitmap.new(Texture.new("kontroller_base.png", true))
self.joyStick.base_bitmap:setVisible(false)
self.joyStick.base_bitmap:setAnchorPoint(0.5, 0.5)
self.joyStick.stick_bitmap = Bitmap.new(Texture.new("kontroller_stick.png", true))
self.joyStick.stick_bitmap:setAnchorPoint(0.5, 0.5)
self.joyStick.stick_bitmap:setVisible(false)
self.joyStick.xStart, self.joyStick.yStart = 0, 0
self.joyStick.tid = 0 --touch id
self.joyStick.isDown = false
self.joyStick.xDelta , self.joyStick.yDelta = 0, 0
self.actionButton.tid = 1 --touch id
self.actionButton.isDown = false	
local JOYSTICK_MAX_DISTANCE = 40
local JOYSTICK_MAX_SQR_DISTANCE = JOYSTICK_MAX_DISTANCE * JOYSTICK_MAX_DISTANCE

local redBox = Bitmap.new(Texture.new("kotak2.png"))
local blueBox = Bitmap.new(Texture.new("kotak.png"))
local yellowBox = Bitmap.new(Texture.new("kotak3.png"))

redBox:setPosition(50, 50)
redBox:setAnchorPoint(.5, .5)
stage:addChild(redBox)

blueBox:setPosition(150, 200)
blueBox:setAnchorPoint(.5, .5)
stage:addChild(blueBox)

yellowBox:setPosition(-50, 0)
yellowBox:setAnchorPoint(.5, .5)
blueBox:addChild(yellowBox) -- deliberate

stage:addChild(self.joyStick.base_bitmap)
stage:addChild(self.joyStick.stick_bitmap)

function move(dx, dy)
	local x
	local y
	x, y = redBox:getPosition()
	x = x + dx
	y = y + dy	
	
	if(x < 0) then
		x = 0
	end
	
	if(x > application:getContentWidth()) then
		x = application:getContentWidth()		
	end
	
	if(y < 0) then
		y = 0		
	end
	
	if(y > application:getContentHeight()) then
		y = application:getContentHeight()		
	end	
	
	redBox:setPosition(x, y)
end

local function onEnterFrame()
		
	if(self.joyStick.isDown) then		
		move(self.joyStick.xDelta * 0.1, self.joyStick.yDelta * 0.1)
	end	
	
	local px, py = blueBox:localToGlobal(-50, 0)	
	local deltax = px - redBox:getX()
	local deltay = py - redBox:getY()
	local angle = math.deg(math.atan2(deltay,deltax))		
	print("px, py : ", px, py, angle)
	
	blueBox:setRotation(angle)
end

function onTouchesBegin(event)					
	
	if(self.joyStick.isDown==false) then
		--joystick		
		self.joyStick.base_bitmap:setVisible(true)
		self.joyStick.stick_bitmap:setVisible(true)
		self.joyStick.isDown = true
		self.joyStick.xStart, self.joyStick.yStart = event.touch.x, event.touch.y	
		self.joyStick.base_bitmap:setPosition(self.joyStick.xStart,self.joyStick.yStart)
		self.joyStick.stick_bitmap:setPosition(self.joyStick.xStart, self.joyStick.yStart)			
		self.joyStick.tid = event.touch.id
		self.joyStick.xDelta, self.joyStick.yDelta = 0, 0			
	elseif(self._controlEnabled and self.actionButton.isDown == false) then
		--action button		
		self.actionButton.isDown = true			
		self.actionButton.tid = event.touch.id		
		self.bulletmanager:setShooting(true)
	end           
end

function onTouchesMove(event)				
	if(self.joyStick.isDown and self.joyStick.tid == event.touch.id) then
		self.joyStick.xDelta, self.joyStick.yDelta = (event.touch.x - self.joyStick.xStart), (event.touch.y - self.joyStick.yStart)			
		
		local sqrdist = self.joyStick.xDelta * self.joyStick.xDelta + self.joyStick.yDelta * self.joyStick.yDelta
		
		if(sqrdist > JOYSTICK_MAX_SQR_DISTANCE) then
			divisor = math.sqrt(JOYSTICK_MAX_SQR_DISTANCE / sqrdist)
			self.joyStick.xDelta = self.joyStick.xDelta * divisor
			self.joyStick.yDelta = self.joyStick.yDelta * divisor
		end		
		
		self.joyStick.stick_bitmap:setPosition(self.joyStick.xStart + self.joyStick.xDelta , self.joyStick.yStart + self.joyStick.yDelta)
		
	end
end

function onTouchesEnd(event)		
	--print("check ", self.actionButton.tid, event.touch.id, self.actionButton.tid == event.touch.id, self.joyStick.tid == event.touch.id)
	if(self.joyStick.isDown and self.joyStick.tid == event.touch.id) then
		self.joyStick.isDown = false			
		self.joyStick.base_bitmap:setVisible(false)
		self.joyStick.stick_bitmap:setVisible(false)
	elseif (self.actionButton.isDown and self.actionButton.tid == event.touch.id) then 		
		self.actionButton.isDown = false		
		self.bulletmanager:setShooting(false)
	end	
end


stage:addEventListener(Event.ENTER_FRAME, onEnterFrame)
stage:addEventListener(Event.TOUCHES_BEGIN, onTouchesBegin)
stage:addEventListener(Event.TOUCHES_MOVE, onTouchesMove)
stage:addEventListener(Event.TOUCHES_END, onTouchesEnd)
